#ifndef DYN_ABSTRACT_CONTEXT_HH
#define DYN_ABSTRACT_CONTEXT_HH

#include<memory>

#include <awali/dyn/core/any.hh>


namespace awali { namespace dyn {

  struct abstract_context_t {

    virtual std::string sname() const =0;
    virtual std::string vname(bool full = true) const =0;
//     virtual std::string latex_name() const = 0;
    virtual std::string labelname() const =0;
    virtual std::string weightname(std::string format="text") const =0;

    virtual std::vector<any_t> alphabet() const = 0;
    virtual any_t epsilon() const = 0;
    virtual void add_letter(any_t) = 0;
    virtual bool has_letter(any_t) const = 0;
    virtual any_t weight_one() const = 0;
    virtual any_t weight_zero() const = 0;

    virtual any_t add_weights(dyn::any_t l, dyn::any_t r) const = 0;
    virtual any_t mul_weights(dyn::any_t l, dyn::any_t r) const = 0;
    virtual any_t div_weights(dyn::any_t l, dyn::any_t r) const = 0;
    
    virtual any_t get_weight(std::string w) const =0;
    virtual any_t get_label(std::string w) const =0;

    virtual std::string weight_to_string(any_t w) const=0;
    virtual std::string label_to_string(any_t w) const=0;


    virtual ~abstract_context_t() {}
  };

  using context_t = std::shared_ptr<abstract_context_t>;

}}//end of ns awali::dyn
#endif
