#ifndef AWALI_ALGOS_READ_HH
# define AWALI_ALGOS_READ_HH

#include <awali/sttc/weightset/polynomialset.hh>

namespace awali { namespace sttc {


  /*-------------.
  | read_label.  |
  `-------------*/

  template <typename Context>
  inline
  auto
  read_label(std::istream& is, const Context& ctx)
    -> label_t_of<Context>
  {
    return ctx.labelset()->conv(is);
  }

  /*------------------.
  | read_polynomial.  |
  `------------------*/

  template <typename Context>
  inline
  auto
  read_polynomial(const Context& ctx, std::istream& is)
    -> typename polynomialset<Context>::value_t
  {
    return polynomialset<Context>(ctx).conv(is);
  }

  /*--------------.
  | read_weight.  |
  `--------------*/

  template <typename Context>
  inline
  auto
  read_weight(const Context& ctx, std::istream& is)
    -> weight_t_of<Context>
  {
    return ctx.weightset()->conv(is);
  }

}}//end of ns awali::stc

#endif // !AWALI_ALGOS_READ_HH
