#ifndef AWALI_ALGOS_SORT_HH
# define AWALI_ALGOS_SORT_HH


# include <algorithm>

namespace awali { namespace sttc {

  template <typename Aut, typename Compare>
  inline
  void
  sort(Aut a, Compare p)
  {
    for(auto s: a->states()) {
      auto& out = a->all_out_(s);
      std::sort(out.begin(), out.end(), p);
    }
  }

  template <size_t I, typename Tdc>
  inline
  void
  sort_tape(Tdc t)
  {
    sort(t, [t](transition_t t1, transition_t t2) {
	auto ls=t->context().labelset()->template set<I>();
	return ls.less_than(std::get<I>(t->label_of(t1)),
			     std::get<I>(t->label_of(t2)));
      });
  }



}}//end of ns awali::stc

#endif // !AWALI_ALGOS_SORT_HH
