#ifndef AWALI_MISC_MEMORY_HH
# define AWALI_MISC_MEMORY_HH

# include <memory>
# include <utility> // std::forward

namespace awali { namespace sttc {

  /// Same as std::make_shared, but parameterized by the shared_ptr type,
  /// not the (pointed to) element_type.
  template <typename SharedPtr, typename... Args>
  SharedPtr
  make_shared_ptr(Args&&... args)
  {
    using type = typename SharedPtr::element_type;
    return std::make_shared<type>(std::forward<Args>(args)...);
  }
}}//end of ns awali::stc

#endif // !AWALI_MISC_MEMORY_HH
